clear all
%session_1 -> step5
%filenames = ["mass_A(a).txt", "mass_B(a).txt", "mass_C(a).txt", "mass_D(a).txt", "mass_E(a).txt", "mass_H(a).txt", "mass_A(b).txt", "mass_B(b).txt", "mass_C(b).txt", "mass_D(b).txt", "mass_F(b).txt", "mass_A(c).txt", "mass_C(c).txt", "mass_D(c).txt", "mass_E(c).txt", "mass_A(e).txt", "mass_B(e).txt", "mass_C(e).txt", "mass_D(e).txt", "mass_E(e).txt", "mass_F(e).txt", "mass_G(e).txt", "mass_H(e).txt", "mass_I(e).txt", "mass_J(e).txt", "mass_K(e).txt", "mass_A(f).txt", "mass_B(f).txt", "mass_C(f).txt", "mass_D(f).txt", "mass_E(f).txt", "mass_F(f).txt", "mass_G(f).txt", "mass_H(f).txt", "mass_I(f).txt"]; % "mass_A(d).txt", "mass_B(d).txt", "mass_C(d).txt", "mass_D(d).txt", "mass_E(d).txt", "mass_F(d).txt", "mass_G(d).txt", "mass_H(d).txt", "mass_I(d).txt"
%session_1 -> step2
%filenames = ["mass_A(a).txt", "mass_B(a).txt", "mass_C(a).txt", "mass_A(b).txt", "mass_B(b).txt", "mass_C(b).txt", "mass_D(b).txt", "mass_A(c).txt", "mass_B(c).txt", "mass_A(d).txt", "mass_B(d).txt", "mass_C(d).txt", "mass_D(d).txt", "mass_E(d).txt", "mass_A(e).txt", "mass_B(e).txt", "mass_C(e).txt", "mass_D(e).txt", "mass_E(e).txt"];
%session_2
filenames = ["1.txt", "2.txt", "3.txt", "4.txt", "5.txt", "6.txt", "7.txt", "8.txt", "9.txt", "10.txt", "11.txt", "12.txt", "13.txt", "14.txt", "15.txt", "16.txt", "17.txt", "18.txt", "19.txt", "20.txt", "21.txt", "22.txt", "23.txt", "24.txt", "25.txt", "26.txt", "27.txt", "28.txt"];


totalfiles = length(filenames);
for n = 1:totalfiles
data = load(filenames(n));
total = length(data);
x = data(:,1);
y = data(:,2);
t = data(:,3);
[theta,r] = cart2pol(x,y);
dr = diff(r);
dt = diff(t);
dx = diff(x);
b(n) = abs(mean(y(1:10)))

j = 2; 
%radial velocity
for i=(1+j):(total-j)
    v_radial(i-2) = (-r(i + j) + 8*r(i + j/2) - 8*r(i - j/2) + r(i - j)) / (6 * j * dt(1));
end
%x velocity
for i=(1+j):(total-j)
    v_x(i-2) = (-x(i + j) + 8*x(i + j/2) - 8*x(i - j/2) + x(i - j)) / (6 * j * dt(1));
end
%y velocity
for i=(1+j):(total-j)
    v_y(i-2) = (-y(i + j) + 8*y(i + j/2) - 8*y(i - j/2) + y(i - j)) / (6 * j * dt(1));
end
%the deflection angle
alpha(n) = atand((y(total) - y(total - 20)) / (x(total) - x(total - 20)));


%alters the dimensions of the time array to make it equal to the veloity
%vectors
t_new = t;
t_new(1:j) = [];
total_new = length(t_new);
t_new((total_new-j+1):total_new) = [];

%finds the point at which the radial velocity is zero and also finds the
%initial velocity
[minVelocity, indexOfMin] = min(abs(v_radial));
R_p(n) = r(indexOfMin);
theta_at_R_p(n) = theta(indexOfMin);
V(n) = abs(mean(v_x(1:5)))
%_______________________________________________________________________________
a1 = 1.256;
a2 = 0.01238;
a3 = 0.2949;
rho = 1141;

r_fit = 0:0.0001:0.04;
E_fit = -(a1 * (a3 + ((r_fit.^6) * a2.^-6)).^(-1));
%plot(r, E_fit, '-');
%hold on;

E_mag = E_fit;
E_eff = E_mag + ((rho * (b(n))^2 * (V(n))^2) ./ (2 * r_fit.^2));
E_initial = ones(1, length(r_fit)) * ((rho * (V(n))^2) / 2);

%plot(r_fit, E_eff);
%hold on;
%plot(r_fit, E_initial);

[a, index] = min(abs(E_eff - E_initial));
R_p_theoretical(n) = r_fit(index)

%_______________________________________________________________________________


%plot(t_new, v_radial, 'LineWidth', 1.5);      % plots the radial velocity against time
%hold on;
%plot(t_new, v_x, 'LineWidth', 1.5);           % plots the x velocity against time
%hold on;
%plot(t_new, v_y, 'LineWidth', 1.5);           % plots the y velocity against time
%hold on;
%polar(theta, r);                              % plots the trajectory on a polar plane
%hold on;

clear vars v_x v_y v_radial; %temporary fix.. i dont know what was going wrong
end


%
figure
plot(b*1000, R_p*1000, 'bo');
hold on;
plot(b*1000, R_p_theoretical*1000, 'ro');
hold on;
xlabel('b (mm)');
ylabel('r_p (mm)');
%
figure
plot(R_p*1000, theta_at_R_p, 'o');
hold on;
xlabel('R_p (mm)');
ylabel('theta at r_p');

%
figure
plot(b*1000, alpha, 'o');
hold on;
xlabel('b (mm)');
ylabel('alpha (degrees)');
%

%
figure
plot(b*1000, V*100, 'o');
hold on;
xlabel('b (mm)');
ylabel('V (cm/s)');
%

