clear all

%magnet A
%r = [4.00 3.75 3.50 3.25 3.00 2.75 2.50 2.25 2.00 1.75 1.50 1.25 1.00 0.75 0.50].*10^-2;
%B = [0.006 0.006 0.006 0.006 0.007 0.007 0.008 0.009 0.011 0.014 0.018 0.026 0.038 0.053 0.054];

%magnet B x 4
r = 5.0:2.5:60;
r = r*(10^-3)
B = [0.090 0.086 0.073 0.053 0.042 0.032 0.024 0.020 0.016 0.013 0.011 0.010 0.009 0.008 0.007 0.007 0.007 0.005 0.005 0.005 0.005 0.005 0.004];

E = (-0.0035/(2*4*pi*(10^-7)))*(B.^2);
%{
figure
plot(r*1000, B, 'o');
xlabel('r (mm)');
ylabel('B (T)');
%hold on;
%}
%{
figure
plot(r*1000, E, 'o')
xlabel('r (mm)');
ylabel('E (J/m^3)');
%hold on;
%}

%magnet A
%{
a1 = 1.256;
a2 = 0.01238;
a3 = 0.2949;
%}

%magnet B x 4   
%
a1 = 0.05249;
a2 = 0.0281;
a3 = 0.004717;
%}


rho = 1141;
b = 0.003;
V = 0.3;

r_fit = 0:0.0001:0.06;
E_fit = -(a1 * (a3 + ((r_fit.^6) * a2.^-6)).^(-1));

%{
figure
plot(r_fit*1000, E_fit, '-', 'LineWidth', 1.5);
hold on;
xlabel('r (mm)');
ylabel('magnetic energy')
%}

E_mag = E_fit;
E_eff = E_mag + ((rho * b^2 * V^2) ./ (2 * r_fit.^2));
E_initial = ones(1, length(r_fit)) * ((rho * V^2) / 2);

%{
figure
plot(r_fit*1000, E_eff, 'LineWidth', 1.5);
hold on;
plot(r_fit*1000, E_initial,'LineWidth', 1.5);
hold on;
xlabel('r (mm)');
ylabel('energy');
%}

[a, index] = min(abs(E_eff - E_initial));
r_p = r_fit(index)


fun = 1./(r_fit.^2 .* sqrt(1 - (2./(rho * V^2)).*E_eff));

plot(r_fit, fun);
hold on;

%plot(r_fit, 2*E_eff./(rho*V^2))
